org.apache.lucene.search

## Class ImpactsDISI

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.search.ImpactsDISI

-     public final class ImpactsDISI
      extends DocIdSetIterator

  `DocIdSetIterator` that skips non-competitive docs thanks to the indexed impacts. Call `setMinCompetitiveScore(float)` in order to give this iterator the ability to skip low-scoring documents.
  NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

      `NO_MORE_DOCS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ImpactsDISI(DocIdSetIterator in, ImpactsSource impactsSource, Similarity.SimScorer scorer)` Sole constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
    `int` | `advanceShallow(int target)` Implement the contract of `Scorer.advanceShallow(int)` based on the wrapped `ImpactsEnum`.
    `long` | `cost()` Returns the estimated cost of this `DocIdSetIterator`.
    `int` | `docID()` Returns the following: `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    `float` | `getMaxScore(int upTo)` Implement the contract of `Scorer.getMaxScore(int)` based on the wrapped `ImpactsEnum` and `Scorer`.
    `int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    `void` | `setMinCompetitiveScore(float minCompetitiveScore)` Set the minimum competitive score.

    - ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

      `all, empty, range, slowAdvance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ImpactsDISI

          public ImpactsDISI(DocIdSetIterator in,
                             ImpactsSource impactsSource,
                             Similarity.SimScorer scorer)

      Sole constructor.
      Parameters:
        `in` - wrapped iterator
        `impactsSource` - source of impacts
        `scorer` - scorer

  - ### Method Detail

    - #### setMinCompetitiveScore

          public void setMinCompetitiveScore(float minCompetitiveScore)

      Set the minimum competitive score.
      See Also:
        `Scorable.setMinCompetitiveScore(float)`

    - #### advanceShallow

          public int advanceShallow(int target)
                             throws IOException

      Implement the contract of `Scorer.advanceShallow(int)` based on the wrapped `ImpactsEnum`.
      Throws:
        `IOException`
      See Also:
        `Scorer.advanceShallow(int)`

    - #### getMaxScore

          public float getMaxScore(int upTo)
                            throws IOException

      Implement the contract of `Scorer.getMaxScore(int)` based on the wrapped `ImpactsEnum` and `Scorer`.
      Throws:
        `IOException`
      See Also:
        `Scorer.getMaxScore(int)`

    - #### advance

          public int advance(int target)
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

      The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

      When `target > current` it behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      Specified by:
        `advance` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### nextDoc

          public int nextDoc()
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Specified by:
        `nextDoc` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### docID

          public int docID()

      Description copied from class: `DocIdSetIterator`
      Returns the following:
      - `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
      - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.
      Specified by:
        `docID` in class `DocIdSetIterator`

    - #### cost

          public long cost()

      Description copied from class: `DocIdSetIterator`
      Returns the estimated cost of this `DocIdSetIterator`.

      This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

      Specified by:
        `cost` in class `DocIdSetIterator`

Copyright © 2000-2024 Apache Software Foundation. All Rights Reserved.